<template>
  <!-- Start Content-->
  <div class="container-fluid">
    <!-- start page title -->
    <div class="row">
      <div class="col-12">
        <div class="page-title-box">
          <h4 class="page-title">Редактирование товара</h4>
        </div>
      </div>
    </div>
    <!-- end page title -->

    <div class="row">
      <div class="col-12">
        <div class="card-box">
          <div class="row">
            <div class="col-lg-12">
              <div class="text-lg-right mt-3 mt-lg-0">
                <router-link :to="'/products/upload'" class="btn btn-danger waves-effect waves-light"><i class="mdi mdi-plus-circle mr-1"></i> Загрузить из файла</router-link>
              </div>
            </div><!-- end col-->
          </div> <!-- end row -->
        </div> <!-- end card-box -->
      </div> <!-- end col-->
    </div>
    <!-- end row-->

    <form>

      <div class="row">
        <div class="col-lg-6">
          <div class="card-box">
            <h5 class="text-uppercase bg-light p-2 mt-0 mb-3">Основное</h5>

            <div class="form-group mb-3">
              <label for="product-name">Наименование товара <span class="text-danger">*</span></label>
              <input type="text" id="product-name" name="product-name" class="form-control" placeholder="e.g : Apple iMac" ref="product_name" v-model="product_name">
            </div>

            <div class="form-group mb-3">
              <label for="product-name">Артикул (sku) <span class="text-danger">*</span></label>
              <input type="text" id="product-sku" name="product-sku" class="form-control" placeholder="e.g : Apple iMac" ref="product_sku" v-model="product_sku">
            </div>

            <div class="form-group mb-3">
              <label for="product-collection">Коллекция</label>
              <input type="text" id="product-collection" name="product-collection" class="form-control" placeholder="e.g : Apple iMac" ref="product_collection" v-model="product_collection">
            </div>

            <div class="form-group mb-3">
              <label for="product-model">Модель <span class="text-danger">*</span></label>
              <input type="text" id="product-model" name="product-model" class="form-control" placeholder="e.g : Apple iMac" ref="product_model" v-model="product_model">
            </div>

            <div class="form-group mb-3">
              <label for="product-category">Страна производства <span class="text-danger">*</span></label>
              <multiselect
                v-model="product_region"
                :options="regions"
                :preselectFirst="true"
                select-label="Нажмите для выбора"
                selected-label="Выбрано"
                deselect-label="Нажмите для удаления"
                placeholder="Выберите страну производства"
                label="name"
                track-by="id"
              />
            </div>

            <div class="form-group mb-3">
              <label for="product-description">Описание товара <span class="text-danger">*</span></label>
              <textarea class="form-control" id="product-description" name="product-description" rows="5" placeholder="Please enter description" ref="product_description" v-model="product_description"></textarea>
            </div>

            <div class="form-group mb-3">
              <label for="product-category">Базовая категория <span class="text-danger">*</span></label>
              <multiselect
                v-model="selected"
                :options="baseCategories"
                :multiple="false"
                :close-on-select="true"
                :clear-on-select="true"
                :preserve-search="true"
                select-label="Нажмите для выбора"
                selected-label="Выбрано"
                deselect-label="Нажмите для удаления"
                placeholder="Выберите базовую категорию"
                label="name"
                track-by="id"
                :preselect-first="false"
              />
            </div>

            <div class="form-group mb-3">
              <label for="product-category">Категория <span class="text-danger">*</span></label>
              <multiselect
                v-model="selectedCategory"
                :options="filteredProducts"
                :multiple="false"
                :close-on-select="true"
                :clear-on-select="true"
                :preserve-search="true"
                :allow-empty="false"
                select-label="Нажмите для выбора"
                selected-label="Выбрано"
                deselect-label="Нажмите для удаления"
                placeholder="Выберите категорию товара"
                label="name"
                track-by="id"
                :preselect-first="false"
              />
            </div>

            <div class="form-group mb-3">
              <label for="product-category">Ценовой сегмент <span class="text-danger">*</span></label>
              <multiselect
                v-model="segment"
                :options="segmentOptions"
                :multiple="true"
                :close-on-select="false"
                :clear-on-select="false"
                :preserve-search="true"
                select-label="Нажмите для выбора"
                selected-label="Выбрано"
                deselect-label="Нажмите для удаления"
                placeholder="Выберете ценовой сегмент"
                label="title"
                track-by="value"
                :preselect-first="true"
              />
            </div>

            <div class="form-group mb-3">
              <label for="product-base_price">Базовая оптовая цена <span class="text-danger">*</span></label>
              <input type="text" class="form-control" id="product-base_price" name="product-base_price" placeholder="Enter amount" ref="product_base_price" v-model="product_base_price">
            </div>

            <div class="form-group mb-3" v-if="false">
              <label for="product-drop_price">Оптовая цена по дропшиппингу</label>
              <input type="text" class="form-control" id="product-drop_price" name="product-drop_price" placeholder="Enter amount" ref="product_drop_price" v-model="product_drop_price">
            </div>

            <div class="form-group mb-3">
              <label for="product-price">РРЦ<span class="text-danger">*</span></label>
              <input type="text" class="form-control" id="product-price" name="product-price" placeholder="Enter amount" ref="product_price" v-model="product_price">
            </div>

            <div class="form-group mb-3">
              <label for="product-sale">Цена по акции</label>
              <input type="text" class="form-control" id="product-sale" name="product-sale" placeholder="Введите цену по акции" ref="product_sale" v-model="product_sale">
            </div>

            <div class="form-group mb-3">
              <label for="product-discount">Скидка</label>
              <input type="text" class="form-control" id="product-discount" name="product-discount" placeholder="5% или 500" ref="product_discount" v-model="product_discount">
            </div>


            <div class="form-group mb-3">
              <label for="product-min_order">Минимальный заказ (шт) </label>
              <input type="text" class="form-control" id="product-min_order" name="product-min_order" placeholder="Enter amount" ref="product_min_order" v-model="product_min_order">
            </div>

            <div class="form-group mb-3">
              <label class="mb-2">Статус <span class="text-danger">*</span></label>
              <multiselect
                v-model="product_status"
                :options="statuses"
                :multiple="false"
                :close-on-select="true"
                :clear-on-select="false"
                :preserve-search="true"
                select-label="Нажмите для выбора"
                selected-label="Выбрано"
                deselect-label="Нажмите для удаления"
                placeholder="Выберете статус товара"
                label="title"
                track-by="value"
                :preselect-first="true"
              />
            </div>
          </div> <!-- end card-box -->
        </div> <!-- end col -->

        <div class="col-lg-6">

          <div class="card-box">
            <h5 class="text-uppercase mt-0 mb-3 bg-light p-2">Изображение товара</h5>

            <input name="images[]" type="file" multiple ref="product_images" accept="image/jpeg,image/png" @change="uploadImg()"/>

            <!-- Preview -->
            <div class="dropzone-previews mt-3" id="file-previews">
              <!-- file preview template -->
              <div class="" id="uploadPreviewTemplate">
                <ImagePreview v-for="(file,key) in files" :key="key" :file="file" :file_id="key"></ImagePreview>
                <ImagePreview v-for="(image,key) in product_media" :key="key" :file="image" :file_id="image.id" :product_image="true"></ImagePreview>
              </div>
            </div>

          </div> <!-- end col-->

          <div class="card-box">
            <h5 class="text-uppercase mt-0 mb-3 bg-light p-2">Характеристики товара</h5>

            <div class="form-group mb-3" v-show="showColors">
              <label for="product-category">Цвет <span class="text-danger">*</span></label>
              <multiselect
                v-model="product_color"
                :options="colors"
                :multiple="false"
                :close-on-select="true"
                :clear-on-select="false"
                :preserve-search="true"
                select-label="Нажмите для выбора"
                selected-label="Выбрано"
                deselect-label="Нажмите для удаления"
                placeholder="Выберете цвет товара"
                label="title"
                track-by="id"
                :preselect-first="true"
              />
            </div>

            <div class="form-group mb-3" v-show="showSizes">
              <label for="product-sizes">Размеры <span class="text-danger">*</span></label>
              <div class="form-group row mb-3" v-for="(size) in getCurrentSizes">
                <label class="col-form-label col-sm-1">{{ size.title }}</label>
                <div class="col-sm-2">
                  <input type="text" :name="size.value" class="form-control" :ref="size.value" placeholder="0" @change="currentSizes($event)" :value="size.stock">
                </div>
                <label class="col-form-label col-sm-1">шт.</label>
                <template v-if="false">
                  <label class="col-form-label col-sm-1">Баркод<span class="text-danger">*</span></label>
                  <div class="col-sm-6">
                    <input type="text" :name="size.value" class="form-control" :ref="size.value" placeholder="0000000000" @change="currentBarcodes($event)" :value="size.barcode">
                  </div>
                </template>
              </div>
            </div>

            <div class="form-group mb-3" v-show="showTextures">
              <label for="product-category">Ткань <span class="text-danger">*</span></label>
              <multiselect
                v-model="product_texture"
                :options="textures"
                :multiple="false"
                :close-on-select="true"
                :clear-on-select="false"
                :preserve-search="true"
                select-label="Нажмите для выбора"
                selected-label="Выбрано"
                deselect-label="Нажмите для удаления"
                placeholder="Выберете цвет товара"
                label="title"
                track-by="id"
                :preselect-first="true"
              />
            </div>

            <div class="form-group mb-3" v-show="showConsist">
              <label for="product-description">Состав<span class="text-danger">*</span></label>
              <textarea class="form-control" id="product-description" name="product-description" rows="5" placeholder="Please enter description" ref="product_consist" v-model="product_consist"></textarea>
            </div>

            <div class="form-group mb-3" v-if="false">
              <label class="mb-2">Модификация товара (Выберите товар)</label>

              <multiselect
                v-model="modification"
                :options="products"
                :multiple="false"
                :close-on-select="true"
                :clear-on-select="true"
                :preserve-search="true"
                select-label="Нажмите для выбора"
                selected-label="Выбрано"
                deselect-label="Нажмите для удаления"
                placeholder="Выберите модификацию товара"
                label="name"
                track-by="id"
                :preselect-first="false"
              />
            </div>

          </div> <!-- end col-->

        </div> <!-- end col-->
      </div>
      <!-- end row -->

      <div class="row">
        <div class="col-12">
          <div class="text-center mb-3">
            <button type="button" class="btn w-sm btn-light waves-effect" @click.prevent="cancel()">Отменить</button>
            <button type="submit" class="btn w-sm btn-success waves-effect waves-light" @click.prevent="getFormValues()">Сохранить</button>
          </div>
        </div> <!-- end col -->
      </div>
      <!-- end row -->

    </form>

    <!-- file preview template -->
    <div class="d-none" id="uploadPreviewTemplate">
      <div class="card mt-1 mb-0 shadow-none border">
        <div class="p-2">
          <div class="row align-items-center">
            <div class="col-auto">
              <img data-dz-thumbnail src="#" class="avatar-sm rounded bg-light" alt="">
            </div>
            <div class="col pl-0">
              <a href="javascript:void(0);" class="text-muted font-weight-bold" data-dz-name></a>
              <p class="mb-0" data-dz-size></p>
            </div>
            <div class="col-auto">
              <!-- Button -->
              <a href="" class="btn btn-link btn-lg text-muted" data-dz-remove>
                <i class="dripicons-cross"></i>
              </a>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div> <!-- container -->
</template>

<script>
export default {
  data() {
    return {
      files: '',
      pageData: {},
      product_id: 0,
      product_name: '',
      product_consist: '',
      product_collection: '',
      product_sku: '',
      product_model: '',
      product_description: '',
      product_region: 0,
      product_color: {},
      product_texture: {},
      product_media: {},
      category_params: {},
      colors: [],
      textures: [],
      category_group_id: 0,
      product_base_price: 0,
      product_drop_price: 0,
      product_price: 0,
      product_sale: 0,
      product_discount: 0,
      product_min_order: 1,
      product_sizes: [],
      product_status: '',
      selectedRegions: [],
      products: [],
      modification: [],
      segment: [],
      regions: [],
      selected: {},
      currentItem: {},
      items: [],
      baseCategories: [],
      categories: [],
      selectedCategory: 0,
      productSelectedCategory: 0,
      currentSelectedCategory: {},
      sizes: [],
      currentSelectedSizes: {},
      currentSelectedBarcodes: {},
      formData: {},
      selected_segments: [],
      segmentOptions: [
        { value: 'low-priced', title: 'Эконом' },
        { value: 'middle-priced', title: 'Средний' },
        { value: 'high-priced', title: 'Высокий' },
        { value: 'premium-priced', title: 'Премиум' }
      ],
      statuses: [
        {value: 'new', title: 'Новинка'},
        {value: 'draft', title: 'Черновик'},
        {value: 'active', title: 'Активно'},
        {value: 'inactive', title: 'Не активно'},
        {value: 'unavailable', title: 'Недоступно'},
        {value: 'promo', title: 'Акция'},
        {value: 'hidden',title: 'Скрыто'},
        {value: 'deleted', title: 'Удалено'},
        {value: 'recommended', title: 'Рекомендуемый'},
        {value: 'repeat', title: 'Ожидается в повторе'},
        {value: 'preorder', title: 'Предзаказ'}
      ],
    }
  },
  computed: {
    showSizes: function(){

      let sizes = this.getCurrentSizes;

        if(sizes.length == 0)
          return false;

        let category_params = this.getCategoryParams();
        if(category_params !== undefined){
          for(let i in category_params){
            if(category_params[i] == 'size'){
              return true;
            }
          }
        }
        return false;
    },
    showColors: function(){
      let category_params = this.getCategoryParams();
      if(category_params !== undefined){
        for(let i in category_params){
          if(category_params[i] == 'color'){
            return true;
          }
        }
      }
      return false;
    },
    showTextures: function(){
      let category_params = this.getCategoryParams();
      if(category_params !== undefined){
        for(let i in category_params){
          if(category_params[i] == 'texture'){
            return true;
          }
        }
      }
      return false;
    },
    showConsist: function(){
      let category_params = this.getCategoryParams();
      if(category_params !== undefined){
        for(let i in category_params){
          if(category_params[i] == 'consist'){
            return true;
          }
        }
      }
      return false;
    },
    filteredProducts: function() {
      if(this.selected.id !== undefined){
        return this.categories[this.selected.id];
      }else{
        return [];
      }
    },
    getCurrentSizes: function(){
      this.sizes = [];
      //this.currentSelectedSizes = {};

      if(this.productSelectedCategory.id == this.selectedCategory.id){
        return this.product_sizes;
      }

      for(let size in this.pageData.sizes){
        if(this.pageData.sizes[size].category_type == this.selectedCategory.type){
          this.sizes.push(this.pageData.sizes[size]);
        }
      }
      return this.sizes;
    }
  },
  methods: {
    getCategoryParams(){
      if(this.selectedCategory.params !== undefined){
        return JSON.parse(this.selectedCategory.params);
      }
    },
    currentSizes(el){
      this.currentSelectedSizes[el.target.name] = el.target.value;
      /*if(this.$refs[el.target.name][1].value === ''){
        this.$refs[el.target.name][1].classList.value = this.$refs[el.target.name][1].classList.value + ' parsley-error';
        this.$refs[el.target.name][1].placeholder = 'Введите баркод!';
      }*/
    },
    currentBarcodes(el){
      this.currentSelectedBarcodes[el.target.name] = el.target.value;
      /*if(this.$refs[el.target.name][0].value !== '' && this.$refs[el.target.name][1].value === ''){
        this.$refs[el.target.name][1].classList.value = this.$refs[el.target.name][1].classList.value + ' parsley-error';
        this.$refs[el.target.name][1].placeholder = 'Введите баркод!';
      }else{
        this.$refs[el.target.name][1].classList.value = 'form-control';
      }*/
    },
    sendPageData(){
      this.$axios.post('/products/update', this.formData,   {
        headers: {
          'Content-Type': 'multipart/form-data'
        }
      })
        .then(resp => {
          this.$router.push('/products/' + this.$route.params.slug);
        })
        .catch(Error => function(){
          alert(Error)
        });
    },
    getPageData(){
      this.$axios.post('/products/edit',{
        'slug' : this.$route.params.slug
      })
        .then(resp => {
          this.pageData = resp.data;
          this.product_id = resp.data.product.id;
          this.regions = resp.data.regions;
          this.categories = resp.data.categories;
          this.product_region = this.getRegionData(resp.data.product.country_made_in);
          this.selected = resp.data.selected;
          this.segment = resp.data.segments;
          this.product_color = resp.data.color;
          this.product_media = resp.data.product.media;
          this.colors = resp.data.colors;
          this.textures = resp.data.texture;
          this.modification = resp.data.modification;
          this.products = resp.data.products;
          this.product_name = resp.data.product.name;
          this.product_status = resp.data.statuses[0];
          this.product_sku = resp.data.product.sku;
          this.product_model = resp.data.product.model;
          this.product_collection = resp.data.product.collection;
          this.product_description = resp.data.product.description;
          this.product_consist = resp.data.product.consist;
          //this.selected_segments = JSON.parse(resp.data.product.segment);
          this.selectedCategory = resp.data.productSelectedCategory;
          this.productSelectedCategory = resp.data.productSelectedCategory;
          this.product_base_price = resp.data.product.price;
          this.product_drop_price = resp.data.product.dropshipping_price;
          this.product_price = resp.data.product.recommended_retail_price;
          this.product_sale = resp.data.product.sale;
          this.product_discount = resp.data.product.discount;
          this.product_min_order = resp.data.product.min_order;
          this.product_sizes = resp.data.sizes_data;
          this.baseCategories = resp.data.baseCategories;
        })
        .catch(Error => function(){
          console.log(Error)
        });
    },
    getCurrentCategory(){
      for(let item in this.pageData.categories){
        if(this.pageData.categories[item].id == this.selected.id){
          this.currentItem = this.pageData.categories[item];
        }
      }
    },
    getFormValues(){
      this.formData = new FormData();
      for( var i = 0; i < this.files.length; i++ ){
        let file = this.files[i];
        this.formData.append('product_images[' + i + ']', file);
      }
      this.formData.append('product_id', this.product_id);
      this.formData.append('product_slug',this.$route.params.slug);
      this.formData.append('product_name', this.product_name);
      this.formData.append('product_collection', this.product_collection);
      this.formData.append('product_barcode', this.product_barcode);
      this.formData.append('product_sku', this.product_sku);
      this.formData.append('product_model', this.product_model);
      this.formData.append('product_region', this.product_region.id);
      this.formData.append('product_description', this.product_description);
      this.formData.append('product_consist', this.product_consist);
      this.formData.append('product_base_category', this.selected.id);
      this.formData.append('product_category', this.selectedCategory.id);
      this.formData.append('product_segment', JSON.stringify(this.segment));
      this.formData.append('product_base_price', this.product_base_price);
      //this.formData.append('product_drop_price', this.product_drop_price.value);
      this.formData.append('product_discount', this.product_discount);
      this.formData.append('product_sales', this.product_sale);
      this.formData.append('product_price', this.product_price);
      this.formData.append('product_min_order', this.product_min_order);
      this.formData.append('product_color', this.product_color);
      if(this.modification !== null){
        this.formData.append('product_modification', this.modification.product_id);
        this.formData.append('product_modification_id', this.modification.id);
      }
      this.formData.append('product_status', this.product_status.value);
      this.formData.append('product_sizes', JSON.stringify(this.currentSelectedSizes));
      this.formData.append('product_barcodes', JSON.stringify(this.currentSelectedBarcodes));

      this.sendPageData();
    },
    getRegionData(region_id){
      for(let region in this.regions){
        if(this.regions[region]['id'] == region_id){
          return this.regions[region];
        }
      }
      return null;
    },
    getCategoryData(category_id){
      for(let category in this.pageData.categories){
        if(this.pageData.categories[category]['id'] == category_id){
          return this.pageData.categories[category];
        }
      }
      return null;
    },
    uploadImg(){
      this.files = [];
      this.files = this.$refs.product_images.files;
    },
    cancel(){
      this.$router.push('/products');
    },
  },
  created: function(){
    this.getPageData();
  }
}
</script>

<style scoped>

</style>
